/* tslint:disable */
/* eslint-disable */
/**
* @param {string} content
* @param {IJsParseOptions | undefined} options
* @returns {IJsNode}
*/
export function parse(content: string, options?: IJsParseOptions): IJsNode;

export interface IJsParseOptions {
  allow_fix_unclose?: boolean;
  allow_self_closing?: boolean;
  case_sensitive_tagname?: boolean;
}



export interface IJsRenderOptions {
  always_close_void?: boolean;
  lowercase_tagname?: boolean;
  minify_spaces?: boolean;
  remove_attr_quote?: boolean;
  remove_comment?: boolean;
  remove_endtag_space?: boolean;
}



export type IJsString = string;



export type IJsNodeTree = {
  uuid?: string;
  depth: number;
  node_type: number;
  begin_at: CodePosAt;
  end_at: CodePosAt;
  content?: Array<string>;
  end_tag?: IJsNodeTree;
  meta?: IJsNodeTagMeta;
  childs?: Array<IJsNodeTree>;
};



export type IJsNodeAttrData = {
  content: string;
  begin_at: CodePosAt;
  end_at: CodePosAt;
};



export type IJsNodeAttr = {
  key?: IJsNodeAttrData;
  value?: IJsNodeAttrData;
  quote: string;
  need_quote: boolean;
};



export type IJsNodeTagMeta = {
  self_closed: boolean;
  auto_fix: boolean;
  name: string;
  attrs: Array<IJsNodeAttr>;
};


/**
* the doc's position
*/
export class CodePosAt {
  free(): void;
/**
* @returns {number}
*/
  col_no: number;
/**
* @returns {number}
*/
  index: number;
/**
* @returns {number}
*/
  line_no: number;
}
/**
*/
export class IJsNode {
  free(): void;
/**
* @returns {IJsNodeTree}
*/
  toJson(): IJsNodeTree;
/**
* @returns {IJsString}
*/
  toString(): IJsString;
/**
* @param {IJsRenderOptions | undefined} options
* @returns {IJsString}
*/
  render(options?: IJsRenderOptions): IJsString;
/**
* @param {string} uuid
* @returns {IJsNode | undefined}
*/
  getTagByUuid(uuid: string): IJsNode | undefined;
}
